INCXOR - Editorial

PROBLEM LINK:

Practice
Contest

Author: Lewin Gan
Testers: Kamil Dębowski
Editorialist: Lewin Gan

DIFFICULTY:

Medium-Hard

PREREQUISITES:

Bitmask DP, Digit DP

PROBLEM:

Find the number of increasing sequences that are also increasing when XOR-ed by another sequence.

QUICK EXPLANATION:

First, it’s helpful to be familiar with digit dp. The state we need to keep is whether or not b_i is strictly less than b_{i+1} and a_i XOR b_i is strictly less than a_{i+1} XOR b_{i+1}. This is a total of 2^(2(N-1)) states per digit.

EXPLANATION:

Using the logic above, we can solve f(bit, mask1, mask2) denoting number of ways given we can fill in the bits 0 to bit. The i-th bit in mask1 (resp mask2) is 1 if and only if b_i (resp a_i XOR b_i) is strictly less than b_{i+1} (resp a_{i+1} XOR b_{i+1}).

Using this logic, we can brute force over all 2^n ways to fill in the current bit for b, make sure they satisfy the constraints in mask, and recurse to smaller cases.

To see more details, see the setter’s solution.

AUTHOR’S AND TESTER’S SOLUTIONS:

Setter
Tester Solution will be added soon.

2 Likes

Hi, Could someone please explain this line

The i-th bit in mask1 (resp mask2) is 1 if and only if b_i (resp a_i XOR b_i) is strictly less than b_{i+1} (resp a_{i+1} XOR b_{i+1}).

in a little more detail.

Thanks a lot for the editorial! :smiley:

The problem setters code is in Java. Can u add the testers or the editorialists code if it is in c++.

2 Likes

I am getting the following error. When i am trying to view setter solution.
This XML file does not appear to have any style information associated with it. The document tree is shown below.

AccessDenied
Access Denied
DFD6142E14778E1F

q8ksHUXrKBP5rEJMT+PLMfPJrf7QoA1NYClZY5jNJaYUDHI2sNXC2HJqwupzjk60sREk5stBkeU=

First, you should be familiar with digit dp. If not, most of the following will not make sense. Let’s just talk about mask1 (mask2 is identical). Since we’re iterating from highest bit to lowest bit, we know that p < q if and only if the highest bit in which p and q differ has a 0 in that position for p and a 1 in that position for q. So, we know that b_i and b_{i+1} have to be the same until some certain bit where b_i has a zero and b_{i+1} has a 1, and after that, they can be whatever they want. Thus, the mask helps us keep track of that state for us.

This is the hardest problem I’ve seen in my whole career…

from where we can learn digit dp? any resources?

Some resources to learn Dynamic Programming:

  1. https://www.codechef.com/learning/2to3star/about
  2. https://www.codechef.com/learning/3to4star/about